#ifndef	_LOG_H_
#define	_LOG_H_


#include <stdio.h>


#ifdef	ENABLE_DBG_LOG_COLOR
#	define DBG_LOG_COLOR_MODE_NORMAL			"\x1b" "[0m"	/**< [h */
#	define DBG_LOG_COLOR_MODE_BLINK				"\x1b" "[5m"	/**< _Ń[h */
#	define DBG_LOG_COLOR_MODE_REVERSE			"\x1b" "[7m"	/**< ][h */
#
#	define DBG_LOG_COLOR_BLACK					"\x1b" "[30m"	/**<  */
#	define DBG_LOG_COLOR_RED					"\x1b" "[31m"	/**<  */
#	define DBG_LOG_COLOR_GREEN					"\x1b" "[32m"	/**<  */
#	define DBG_LOG_COLOR_YELLOW					"\x1b" "[33m"	/**<  */
#	define DBG_LOG_COLOR_BLUE					"\x1b" "[34m"	/**<  */
#	define DBG_LOG_COLOR_PURPLE					"\x1b" "[35m"	/**<  */
#	define DBG_LOG_COLOR_LIGHT_BLUE				"\x1b" "[36m"	/**< F */
#	define DBG_LOG_COLOR_WHITE					"\x1b" "[37m"	/**<  */
#
#	define DBG_LOG_COLOR_REVERSE_BLACK			"\x1b" "[40m"	/**< ] */
#	define DBG_LOG_COLOR_REVERSE_RED			"\x1b" "[41m"	/**< ] */
#	define DBG_LOG_COLOR_REVERSE_GREEN			"\x1b" "[42m"	/**< ] */
#	define DBG_LOG_COLOR_REVERSE_YELLOW			"\x1b" "[43m"	/**< ] */
#	define DBG_LOG_COLOR_REVERSE_BLUE			"\x1b" "[44m"	/**< ] */
#	define DBG_LOG_COLOR_REVERSE_PURPLE			"\x1b" "[45m"	/**< ] */
#	define DBG_LOG_COLOR_REVERSE_LIGHT_BLUE		"\x1b" "[46m"	/**< ]F */
#	define DBG_LOG_COLOR_REVERSE_WHITE			"\x1b" "[47m"	/**< ] */
#
#	define DBG_LOG_COLOR_ERR					DBG_LOG_COLOR_RED
#	define DBG_LOG_COLOR_WRN					DBG_LOG_COLOR_YELLOW
#	define DBG_LOG_COLOR_INF					DBG_LOG_COLOR_LIGHT_BLUE
#	define DBG_LOG_COLOR_ENT					DBG_LOG_COLOR_MODE_NORMAL
#	define DBG_LOG_COLOR_LEV					DBG_LOG_COLOR_MODE_NORMAL
#
#	define DBG_LOG(color, label, format, ...)	printf(color "[DBG]" label "[%s(%d)] " format DBG_LOG_COLOR_MODE_NORMAL "\n", __FUNCTION__, __LINE__, ## __VA_ARGS__)
#
#	define DBG_LOG_NORMAL(format, ...)			DBG_LOG(DBG_LOG_COLOR_MODE_NORMAL, "", format, ## __VA_ARGS__)
#	define DBG_LOG_RED(format, ...)				DBG_LOG(DBG_LOG_COLOR_RED, "", format, ## __VA_ARGS__)
#	define DBG_LOG_GREEN(format, ...)			DBG_LOG(DBG_LOG_COLOR_GREEN, "", format, ## __VA_ARGS__)
#	define DBG_LOG_YELLOW(format, ...)			DBG_LOG(DBG_LOG_COLOR_YELLOW, "", format, ## __VA_ARGS__)
#	define DBG_LOG_BLUE(format, ...)			DBG_LOG(DBG_LOG_COLOR_BLUE, "", format, ## __VA_ARGS__)
#	define DBG_LOG_PURPLE(format, ...)			DBG_LOG(DBG_LOG_COLOR_PURPLE, "", format, ## __VA_ARGS__)
#	define DBG_LOG_LIGHT_BLUE(format, ...)		DBG_LOG(DBG_LOG_COLOR_LIGHT_BLUE, "", format, ## __VA_ARGS__)
#else
#	define DBG_LOG(label, format, ...)			printf("[DBG]" label "[%s(%d)] " format "\n", __FUNCTION__, __LINE__, ## __VA_ARGS__)
#
#	define DBG_LOG_NORMAL(format, ...)			DBG_LOG("", format, ## __VA_ARGS__)
#	define DBG_LOG_RED(format, ...)				DBG_LOG_NORMAL(format, ## __VA_ARGS__)
#	define DBG_LOG_GREEN(format, ...)			DBG_LOG_NORMAL(format, ## __VA_ARGS__)
#	define DBG_LOG_YELLOW(format, ...)			DBG_LOG_NORMAL(format, ## __VA_ARGS__)
#	define DBG_LOG_BLUE(format, ...)			DBG_LOG_NORMAL(format, ## __VA_ARGS__)
#	define DBG_LOG_PURPLE(format, ...)			DBG_LOG_NORMAL(format, ## __VA_ARGS__)
#	define DBG_LOG_LIGHT_BLUE(format, ...)		DBG_LOG_NORMAL(format, ## __VA_ARGS__)
#endif

#ifdef	DBG_LOG_LEVEL_UT
#	undef	DBG_LOG_LEVEL
#	define	DBG_LOG_LEVEL	DBG_LOG_LEVEL_UT
#endif

#if DBG_LOG_LEVEL >= 1
#	if !defined(WIN32) && defined(ENABLE_DBG_LOG_COLOR)
#		define DBG_LOG_ERR(label, format, ...)		DBG_LOG(DBG_LOG_COLOR_ERR, label "[ERR]", format, ## __VA_ARGS__)
#	else
#		define DBG_LOG_ERR(label, format, ...)		DBG_LOG(label "[ERR]", format, ## __VA_ARGS__)
#	endif
#else
#	define DBG_LOG_ERR(label, format, ...)
#endif

#if DBG_LOG_LEVEL >= 2
#	if !defined(WIN32) && defined(ENABLE_DBG_LOG_COLOR)
#		define DBG_LOG_WRN(label, format, ...)		DBG_LOG(DBG_LOG_COLOR_WRN, label "[WRN]", format, ## __VA_ARGS__)
#	else
#		define DBG_LOG_WRN(label, format, ...)		DBG_LOG(label "[WRN]", format, ## __VA_ARGS__)
#	endif
#else
#	define DBG_LOG_WRN(label, format, ...)
#endif

#if DBG_LOG_LEVEL >= 3
#	if !defined(WIN32) && defined(ENABLE_DBG_LOG_COLOR)
#		define DBG_LOG_INF(label, format, ...)		DBG_LOG(DBG_LOG_COLOR_INF, label "[INF]", format, ## __VA_ARGS__)
#	else
#		define DBG_LOG_INF(label, format, ...)		DBG_LOG(label "[INF]", format, ## __VA_ARGS__)
#	endif
#else
#	define DBG_LOG_INF(label, format, ...)
#endif

#if DBG_LOG_LEVEL >= 4
#	if !defined(WIN32) && defined(ENABLE_DBG_LOG_COLOR)
#		define DBG_LOG_ENT(label, format, ...)		DBG_LOG(DBG_LOG_COLOR_ENT, label "[ENT]", format, ## __VA_ARGS__)
#		define DBG_LOG_LEV(label, format, ...)		DBG_LOG(DBG_LOG_COLOR_LEV, label "[LEV]", format, ## __VA_ARGS__)
#	else
#		define DBG_LOG_ENT(label, format, ...)		DBG_LOG(label "[ENT]", format, ## __VA_ARGS__)
#		define DBG_LOG_LEV(label, format, ...)		DBG_LOG(label "[LEV]", format, ## __VA_ARGS__)
#	endif
#else
#	define DBG_LOG_ENT(label, format, ...)
#	define DBG_LOG_LEV(label, format, ...)
#endif


#endif	// _LOG_H_
